;(function() {
  // wx
  var wx = function() {};
  wx.prototype.ready = function(fn) {
    fn();
  };
  wx.prototype.onMenuShareTimeline = function(param) {
    this.tuishou.invoke('onMenuShareTimeline', param);
  };
  wx.prototype.onMenuShareAppMessage = function(param) {
    this.tuishou.invoke('onMenuShareAppMessage', param);
  };
  wx.prototype.onMenuShareQQ = function(param) {
    this.tuishou.invoke('onMenuShareQQ', param);
  };
  wx.prototype.onMenuShareQZone = function(param) {
    this.tuishou.invoke('onMenuShareQZone', param);
  };
  wx.prototype.previewImage = function(param) {
    this.tuishou.invoke('previewImage', param);
  };
  
  
  // wx.tuishou
  var tuishou = function() {};
  tuishou.prototype.invoke = function(name, param, cb) {
    var successCb = param['success'];
    delete param['success'];
    var cancelCb = param['cancel'];
    delete param['cancel'];

    if (!!cb) {
      window.appHost.invoke(name, param, cb);
    } else if (!!successCb && !!cancelCb) {
      window.appHost.blockInvoke(name, param, successCb, cancelCb);  
    } else if (!!successCb) {
      window.appHost.invoke(name, param, successCb)
    }  else if (!!cancelCb) {
      window.appHost.invoke(name, param, cancelCb)
    }  else {
      window.appHost.invoke(name, param)
    } 
  };
  
  // 目前会加载微信的js 所以这里不做判断，直接替换
//  if (!!!window.wx) {
    var wx = new wx;
    wx.tuishou = new tuishou;
    window.wx = wx;
//  }
  if (!!!window.wx.tuishou) {
      window.wx.tuishou = new tuishou;
  }
})();

// Common appHost.js
(function() {
  var version = '1.0';
  var urlPrefix = 'js://invoke?';
  var nativeEventPrefix = 'appHostEvent_';
  var proxyUrlPrefix = 'js://proxyInvoke?';

  var isAndroid = (function() {
    return navigator.userAgent.match( /Android/ );
  })();

  var appHost = function () {
    this.serialNo = 0;
    this.callbacks = {};
    this.successCallbacks = {};
    this.cancelCallbacks = {};
  };

  appHost.prototype.version = version;

  appHost.prototype.blockInvoke = function(name, param, successCb, cancelCb) {
    ++this.serialNo;
    var serialNo = this.serialNo;
    if (!!successCb) {
      this.successCallbacks[serialNo] = successCb;
    }
    if (!!cancelCb) {
      this.cancelCallbacks[serialNo] = cancelCb;
    }
    if (isAndroid) {
      this.invokeOnAndroid(name, param, this.serialNo);
    } else {
      this.invokeOnIos(name, param, this.serialNo);
    }
  };

  appHost.prototype.invoke = function(name, param, cb) {
    ++this.serialNo;
    var serialNo = this.serialNo;
    if (!!cb) {
      this.callbacks[serialNo] = cb;
    }
    if (isAndroid) {
      this.invokeOnAndroid(name, param, this.serialNo);
    } else {
      this.invokeOnIos(name, param, this.serialNo);
    }
  };

  appHost.prototype.invokeOnAndroid = function (name, param, serialNo) {
    var obj = {"name": name, "params": param, "version":version, "serial":serialNo};
    var command = encodeURIComponent(JSON.stringify(obj));
    if(command) {
      window.prompt(urlPrefix + command);
    }
  };

  appHost.prototype.invokeOnIos = function (name, param, serialNo) {
    var location = urlPrefix + 'version=' + version + '&name=' + encodeURIComponent(name) + '&param=' + encodeURIComponent(JSON.stringify(param)) + '&serial=' + serialNo;
    window.console.log(location);

    var ob = window.webkit.messageHandlers[name];
    if (typeof ob === 'object') {
      ob.postMessage({'version':version,'serial':serialNo,'param':param});
    }
  };

  appHost.prototype.proxyInvoke = function(product, name, param, cb) {
    ++this.serialNo;
    var serialNo = this.serialNo;
    if (!!cb) {
      this.callbacks[serialNo] = cb;
    }
    if (isAndroid) {
      this.proxyInvokeOnAndroid(product, name, param, this.serialNo);
    } else {
      this.proxyInvokeOnIos(product, name, param, this.serialNo);
    }
  };

  appHost.prototype.proxyInvokeOnAndroid = function (product, name, param, serialNo) {
    var obj = {"product": product, "name": name, "params": param, "version":version, "serial":serialNo};
    var command = encodeURIComponent(JSON.stringify(obj));
    if(command) {
      window.prompt(proxyUrlPrefix + command);
    }
  };

  appHost.prototype.proxyInvokeOnIos = function (product, name, param, serialNo) {
    var location = proxyUrlPrefix + 'version=' + version + '&product=' + encodeURIComponent(product) + '&name=' + encodeURIComponent(name) + '&param=' + encodeURIComponent(JSON.stringify(param)) + '&serial=' + serialNo;
    window.console.log(location);

    var ob = window.webkit.messageHandlers[name];
    if (typeof ob === 'object') {
      ob.postMessage({'version':version,'product':product,'serial':serialNo,'param':param});
    }
  };

  appHost.prototype.onInvokeResult = function(serailNo, param) {
    var cb = this.callbacks[serailNo];
    if (!!!cb) {
        window.console.log("non-existed serail: " + serailNo);
        return;
    }
    delete this.callbacks[serailNo];
    cb(param);
  };

  appHost.prototype.onSuccessResult = function(serailNo, param) {
    var cb = this.successCallbacks[serailNo];
    if (!!!cb) {
        window.console.log("non-existed serail: " + serailNo);
        return;
    }
    delete this.callbacks[serailNo];
    cb(param);
  };

  appHost.prototype.onCancelResult = function(serailNo, param) {
    var cb = this.cancelCallbacks[serailNo];
    if (!!!cb) {
        window.console.log("non-existed serail: " + serailNo);
        return;
    }
    delete this.callbacks[serailNo];
    cb(param);
  };

  appHost.prototype.onProxyInvokeResult = function(serailNo, param) {
    var cb = this.callbacks[serailNo];
    if (!!!cb) {
      window.console.log("non-existed serail: " + serailNo);
      return;
    }
      delete this.callbacks[serailNo];
      cb(param);
  };

  appHost.prototype.onNativeCall = function(obj) {
    if (obj) {
      var name = obj["name"];
      var params = obj["params"];
      if ("onInvokeResult" === name) {
        var id = params["serial"];
        delete params["serial"];
        this.onInvokeResult(id, params);
      } else if ("onProxyInvokeResult" === name) {
        var id = params["serial"];
        delete params["serial"];
        this.onProxyInvokeResult(id, params);
      } else if ("onSuccessResult" === name) {
        var id = params["serial"];
        delete params["serial"];
        this.onSuccessResult(id, params);
      } else if ("onCancelResult" === name) {
        var id = params["serial"];
        delete params["serial"];
        this.onCancelResult(id, params);
      } else if ("trigger" == name) {
        appHost.event.trigger(params["type"], params["detail"]);
      }
    }
  };

  var appHostEvent = function() {};

  appHostEvent.prototype.on = function(type, cb) {
    document.addEventListener(nativeEventPrefix + type, cb, false);
  };

  appHostEvent.prototype.trigger = function(type, detail) {
    var ev = document.createEvent('Event');
    ev.initEvent(nativeEventPrefix + type, true, true);
    ev.detail = detail;
    document.dispatchEvent(ev);
  };

  appHost.prototype.launchActivity = function (url) {
    this.invoke('launchActivity', {'url' : url});
  };

  appHost.prototype.log = function (msg) {
    this.invoke('log', {'msg' : msg});
  };

  if (!!!window.appHost) {
    var appHost = new appHost;
    appHost.event = new appHostEvent;
    window.appHost = appHost;
    if (!!!window.console || !!!window.console.log) {
      window.console.log = window.appHost.log;
    }
    if (!!window.appHostOnLoad) {
      window.appHostOnLoad();
    }
  }
})();
